"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/*
 * @Author: saber2pr
 * @Date: 2019-07-15 08:49:51
 * @Last Modified by: saber2pr
 * @Last Modified time: 2019-08-30 14:59:28
 */
var react_1 = __importStar(require("react"));
var prism_light_1 = __importDefault(require("react-syntax-highlighter/dist/esm/prism-light"));
var typescript_1 = __importDefault(require("react-syntax-highlighter/dist/esm/languages/prism/typescript"));
var reg_1 = require("../../reg");
var core_1 = require("../../core");
exports.Md2jsx = function (_a) {
    var children = _a.children, theme = _a.theme;
    var jsx = [];
    var lines = core_1.mergeCode(children.split("\n"));
    for (var i = 0; i < lines.length; ++i) {
        var line = lines[i];
        if (line.startsWith("```")) {
            renderCode({ jsx: jsx, i: i, line: line, theme: theme });
        }
        else if (line.startsWith("#")) {
            renderHeader({ jsx: jsx, i: i, line: line });
        }
        else if (line.startsWith(">")) {
            renderComment({ jsx: jsx, i: i, line: line });
        }
        else if (reg_1.REG.imgtype.test(line)) {
            renderImg({ jsx: jsx, i: i, line: line });
        }
        else if (line.startsWith("---") || line.startsWith("***")) {
            renderHR({ jsx: jsx, i: i, line: line });
        }
        else {
            jsx.push(react_1.default.createElement("p", { key: i }, line));
        }
    }
    return react_1.default.createElement(react_1.default.Fragment, null, jsx);
};
var renderCode = function (_a) {
    var line = _a.line, jsx = _a.jsx, theme = _a.theme, i = _a.i;
    var codetype = reg_1.REG.codetype.exec(line)[0].slice(3);
    var code = line.slice(codetype.length + 4, line.length - 4);
    prism_light_1.default.registerLanguage(codetype, typescript_1.default);
    jsx.push(react_1.default.createElement(prism_light_1.default, { key: i, language: codetype, style: theme }, code));
};
var renderHeader = function (_a) {
    var line = _a.line, jsx = _a.jsx, i = _a.i;
    var count = 0;
    var text = "";
    for (var _i = 0, line_1 = line; _i < line_1.length; _i++) {
        var ch = line_1[_i];
        if (ch === "#") {
            count++;
        }
        else {
            text += ch;
        }
    }
    jsx.push(react_1.default.createElement(react_1.Fragment, { key: i }, react_1.default.createElement("h" + count, null, text)));
};
var renderComment = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    jsx.push(react_1.default.createElement("p", { key: i, style: { color: "gray" } }, line.slice(2)));
};
var renderImg = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    var meta = line.match(reg_1.REG.imgtype)[0];
    var title = meta.match(reg_1.REG.imgtype_title)[0].replace(/\[|\]/g, "");
    var url = meta.match(reg_1.REG.imgtype_url)[0].replace(/\(|\)/g, "");
    jsx.push(react_1.default.createElement("img", { key: i, src: url, alt: title }));
};
var renderHR = function (_a) {
    var jsx = _a.jsx, i = _a.i, line = _a.line;
    jsx.push(react_1.default.createElement("hr", { key: i }));
};
